dispEn:			;displays the enemy at current location
	ld a,(enRow)
	ld b,8
	call multiply
	ld l,a
	ld a,(enCol)
	ld b,8
	call multiply
	ld b,8
	ld ix,enemy
	call iPutSpriteMask
	ret
dispLoc:		;displays you at current location
	ld a,(rowLoc)
	ld b,8
	call multiply
	ld l,a
	ld a,(column)
	ld b,8
	call multiply
	ld b,8
	ld ix,you
	call iPutSpriteMask
	ret
StoreLoc:			;stores your current location
	ld a, (column)
	ld (colStore), a
	ld a, (rowLoc)
	ld (rowStore), a
	ret
StoreEn:			;stores enemie's current location
	ld a, (enCol)
	ld (colStoreEn), a
	ld a, (enRow)
	ld (rowStoreEn), a
	ret
dispStats:			;displays the current stats
	ld a, 0
	ld (pencol),a
	ld (penrow),a
	ld HL, (timer)
	call vDispHL	;display amount of moves
	ld a, 40
	ld (pencol),a
	ld a, 0
	ld (penrow),a
	ld HL, (health)
	call vDispHL	;display enemy health
	ret
menuTitle:			;display the menu title/author name
	ld a,4
	ld (curcol),a
	ld a,0
	ld (currow),a
	ld hl,GameName
	b_call _putS
	ld a,6
	ld (curcol),a
	ld a,7
	ld (currow),a
	ld hl,Author
	b_call _putS
	ret
menuItem:			;display the current menu item
	ld a, 3
	ld (currow), a
	ld a, 5
	ld (curcol), a
	ld a,b
	add a,a
	add a,b
	add a,a
	ld hl, menu
	add a,L
	ld L,a
	jr nc,$+3
	inc h
	b_call _putS
	ret
menuItem2:		;display the current menu item
	ld a, 3
	ld (currow), a
	ld a, 5
	ld (curcol), a
	ld a,b
	add a,a
	add a,a
	add a,b
	ld hl, difficulties
	add a,L
	ld L,a
	jr nc,$+3
	inc h
	b_call _putS
	ret
iRandom:		;ion's random number routine
	push	hl
	push	de
	ld	hl,(randData)
	ld	a,r
	ld	d,a
	ld	e,(hl)
	add	hl,de
	add	a,l
	xor	h
	ld	(randData),hl
	sbc	hl,hl
	ld	e,a
	ld	d,h
iRandomLoop:
	add	hl,de
	djnz	iRandomLoop
	ld	a,h
	pop	de
	pop	hl
	ret
multiply:
;input: a-multiply
;		b-how many times
	ld c,a
	dec b
	ret z
multloop:
	add a,c
	djnz multloop
	ret
subtract:
;input: a-number to subtract from
;		b-number to subtract
	dec a
	djnz subtract
	ret
reset:
;resets all stats
	xor a
	ld (timer),a
	ld (column),a
	ld a,1
	ld (rowLoc),a
	ld a,7
	ld (enRow),a
	ld a,11
	ld (enCol),a
	ret
grabElement:
; input: A-element number
;		 HL-list name
;		 b-element size
;output: a-element (if one byte)
;;		 HL-Element (if more then one byte)
	call multiply
    LD     d, 0
    LD     e,a              ; Put A in DE
    ADD    HL, DE
    LD     a, (HL)
	ret
writeElement:
; input: A-element number
;		 HL-list name
;		 c-element value
	LD d, 0
	LD e,a 			; Put A in DE
	ADD HL,DE
	ld a,c
	LD (HL),a
	ret
dispTrees:
;displays tree's from the array trees
;no inputs neccessary
;requires: 	multiply
;			grabElement
;			iPutSprite
	ld a,0
	ld (tmp1),a
	ld a,10
	ld (tmp2),a
treeloop:
	ld HL,trees
	ld a, (tmp1)
	ld b,1
	call grabElement
	ld b,8
	call multiply
	ld (colStore),a
	ld hl,trees
	ld a,(tmp1)
	inc a
	ld (tmp1),a
	ld b,1
	call grabElement
	ld b,8
	call multiply
	ld l,a
	ld a,(colStore)
	ld ix,tree
	ld b,8
	call iPutSprite
	ld a,(tmp1)
	inc a
	ld (tmp1),a
	ld a,(tmp2)
	dec a
	ld (tmp2),a
	jr nz, treeloop
	ret
createTree:
;fills the trees array with random coordinates
;requires:
;			iRandom
;			writeElement
	ld a,0
	ld (tmp1),a
	ld a,10
	ld (tmp2),a
createLoop:
	ld b,15
	call iRandom
	ld c,a
	ld HL,trees
	ld a, (tmp1)
	ld b,1
	call writeElement
	ld b,6
	call iRandom
	inc a
	ld c,a
	ld hl,trees
	ld a,(tmp1)
	inc a
	ld (tmp1),a
	ld b,1
	call writeElement
createskip:
	ld a,(tmp1)
	inc a
	ld (tmp1),a
	ld a,(tmp2)
	dec a
	ld (tmp2),a
	jr nz, createloop
	ret
;-----> Draw a sprite
; b=size of sprite
; l=yc
; a=xc
; ix holds pointer
iPutSprite:
	ld	e,l
	ld	h,$00
	ld	d,h
	add	hl,de
	add	hl,de
	add	hl,hl
	add	hl,hl
	ld	e,a
	and	$07
	ld	c,a
	srl	e
	srl	e
	srl	e
	add	hl,de
	ld	de,plotsscreen
	add	hl,de
iPutSpriteLoop1:
sl1:	ld	d,(ix)
	ld	e,$00
	ld	a,c
	or	a
	jr	z,iPutSpriteSkip1
iPutSpriteLoop2:
	srl	d
	rr	e
	dec	a
	jr	nz,iPutSpriteLoop2
iPutSpriteSkip1:
	ld	a,(hl)
	xor	d
	ld	(hl),a
	inc	hl
	ld	a,(hl)
	xor	e
	ld	(hl),a
	ld	de,$0B
	add	hl,de
	inc	ix
	djnz	iPutSpriteLoop1
	ret
;-----> Copy the gbuf to the screen, guaranteed 
;Courtesy of Jim E.
;Input: nothing
;Output:graph buffer is copied to the screen, no matter the speed settings
;
;in f,(c) is an unofficial instruction.
;It must be noted that you cannot specify any other register. Only f works.
;You may have to add it in order for the routine to work.

 .addinstr IN	F,(C)	70ED	2	NOP	1

iFastCopy:
	ld a,i
	push af
		di
		ld c,$10
setrow:
		in a,(c)
		rla ;test 7th bit
		jr c,setrow
		ld a,$80
		out ($10),a
		ld hl,plotsscreen
		ld de,12
		ld a,$20
col:
		push af ;the push and pop are wasted clocks
colwait: ;but this only occurs 12 times
		in a,(c)
		rla
		jr c,colwait
		pop af
		out ($10),a
		push af
		ld b,64
row:
		in a,(c)
		rla
		jr c,row
		ld a,(hl)
		out ($11),a
		add hl,de
		djnz row
		pop af
		dec h
		dec h
		dec h
		inc hl
		inc a
		cp $2c
		jr nz,col
		pop af
	ret po
#ifdef enablecn2eis
	ei
#endif
	ret
VDispA:
;dcs's vDispA currently unused
	bcall(_setxxop1)
	ld a,8
	bcall(_dispop1a)
	ret
VDispHL:
;DCS's vDispHL currently unused
	bcall(_setxxxxop2)
	bcall(_op2toop1)
	ld a,8
	bcall(_dispop1a)
	ret
iPutSpriteMask:
;DCS's iPutSpriteMask
	ld	e,l
	ld	h,$00
	ld	d,h
	add	hl,de
	add	hl,de
	add	hl,hl
	add	hl,hl
	ld	e,a
	and	$07
	ld	c,a
	srl	e
	srl	e
	srl	e
	add	hl,de
	ld	de,plotsscreen
	add	hl,de
iPutSpriteLoop1Mask:
	ld	d,(ix)
	ld	e,$FF
	ld	a,c
	or	a
	jr	z,iPutSpriteSkip1Mask
iPutSpriteLoop2Mask:
	srl	d
	rr	e
	set 7,d
	dec	a
	jr	nz,iPutSpriteLoop2Mask
iPutSpriteSkip1Mask:
	ld	a,(hl)
	and	d
	ld	(hl),a
	inc	hl
	ld	a,(hl)
	and	e
	ld	(hl),a
	push ix
	dec hl
	ld de,8
	add ix,de
iPutSpriteLoop1AND:
	ld	d,(ix)
	ld	e,$00
	ld	a,c
	or	a
	jr	z,iPutSpriteSkip1AND
iPutSpriteLoop2AND:
	srl	d
	rr	e
	dec	a
	jr	nz,iPutSpriteLoop2AND
iPutSpriteSkip1AND:
	ld	a,(hl)
	xor	d
	ld	(hl),a
	inc	hl
	ld	a,(hl)
	xor	e
	ld	(hl),a

	pop ix
	ld	de,$0B
	add	hl,de
	inc	ix
	djnz	iPutSpriteLoop1Mask
	ret
clearbuff:
;clears the buffer
	ld hl,plotsscreen ;copy from here
	ld (hl),0 ;write first byte
	ld de,plotsscreen+1 ;copy to here
	ld bc,768-1 ;copy all but the first byte
	ldir